<?php
/**
 * rep2- Xbh\ NX
 */

require_once P2_LIB_DIR . '/threadread.class.php';

// {{{ ShowThread

abstract class ShowThread
{
    // {{{ properties

    static private $_matome_count = 0;

    protected $_matome; // ܂Ƃߓǂ݃[h̃Xbhԍ

    protected $_str_to_link_regex; // Nׂ̐K\

    protected $_url_handlers; // URL֐E\bhȂǂi[ziftHgj
    protected $_user_url_handlers; // URL֐E\bhȂǂi[zi[U`AftHĝ̂Dj

    protected $_ngaborn_frequent; // poIDځ[񂷂

    protected $_aborn_nums; // ځ[񃌃Xԍi[z
    protected $_ng_nums; // NGXԍi[z

    public $thread; // XbhIuWFNg

    public $activeMona; // ANeBui[EIuWFNg
    public $am_enabled = false; // ANeBui[Lۂ

    // }}}
    // {{{ constructor

    /**
     * RXgN^
     */
    protected function __construct(ThreadRead $aThread, $matome = false)
    {
        global $_conf;

        // XbhIuWFNgo^
        $this->thread = $aThread;

        // ܂Ƃߓǂ݃[hۂ
        if ($matome) {
            $this->_matome = ++self::$_matome_count;
        } else {
            $this->_matome = false;
        }

        $this->_str_to_link_regex = '{'
            . '(?P<link>(<[Aa] .+?>)(.*?)(</[Aa]>))' // NiPCRE̓AK̃p^[ŏɎsj
            . '|'
            . '(?:'
            .   '(?P<quote>' // p
            .       '((?:&gt;|){1,2} ?)' // p
            .       '('
            .           '(?:[1-9]\\d{0,3})' // 1ڂ̔ԍ
            .           '(?:'
            .               '(?: ?(?:[,=]|A) ?[1-9]\\d{0,3})+' // A
            .               '|'
            .               '-(?:[1-9]\\d{0,3})?' // ͈
            .           ')?'
            .       ')'
            .       '(?=\\D|$)'
            .   ')' // p܂
            . '|'
            .   '(?P<url>(ftp|h?t?tps?)://([0-9A-Za-z][\\w!#%&+*,\\-./:;=?@\\[\\]^~]+))' // URL
            .   '([^\s<>]*)' // URL̒A^OorzCgXy[X܂ł̕
            . '|'
            .   '(?P<id>ID: ?([0-9A-Za-z/.+]{8,11})(?=[^0-9A-Za-z/.+]|$))' // IDi8,10 +PC/gюʃtOj
            . ')'
            . '}';

        $this->_url_handlers = array();
        $this->_user_url_handlers = array();

        $this->_ngaborn_frequent = 0;
        if ($_conf['ngaborn_frequent']) {
            if ($_conf['ngaborn_frequent_dayres'] == 0) {
                $this->_ngaborn_frequent = $_conf['ngaborn_frequent'];
            } elseif ($this->thread->setDayRes() && $this->thread->dayres < $_conf['ngaborn_frequent_dayres']) {
                $this->_ngaborn_frequent = $_conf['ngaborn_frequent'];
            }
        }

        $this->_aborn_nums = array();
        $this->_ng_nums = array();
    }

    // }}}
    // {{{ abstract methods
    // {{{ datToHtml()

    /**
     * DatHTMLϊĕ\
     */
    abstract public function datToHtml();

    // }}}
    // {{{ transRes()

    /**
     * DatXHTMLXɕϊ
     *
     * @param   string  $ares   dat1C
     * @param   int     $i      Xԍ
     * @return  string
     */
    abstract public function transRes($ares, $i);

    // }}}
    // {{{ transName()

    /**
     * OHTMLpɕϊ
     *
     * @param   string  $name   O
     * @return  string
     */
    abstract public function transName($name);

    // }}}
    // {{{ transMsg()

    /**
     * dat̃XbZ[WHTML\pbZ[Wɕϊ
     *
     * @param   string  $msg    bZ[W
     * @param   int     $mynum  Xԍ
     * @return  string
     */
    abstract public function transMsg($msg, $mynum);

    // }}}
    // }}}
    // {{{ getDatToHtml()

    /**
     * DatHTMLϊ̂擾
     */
    public function getDatToHtml()
    {
        ob_start();
        $this->datToHtml();
        $html = ob_get_contents();
        ob_end_clean();

        return $html;
    }

    // }}}
    // {{{ replaceBeId()

    /**
     * BEvt@CNϊ
     */
    public function replaceBeId($date_id, $i)
    {
        global $_conf;

        $beid_replace = "<a href=\"http://be.2ch.net/test/p.php?i=\$1&u=d:http://{$this->thread->host}/test/read.cgi/{$this->thread->bbs}/{$this->thread->key}/{$i}\"{$_conf['ext_win_target_at']}>Lv.\$2</a>";

        //<BE:23457986:1>
        $be_match = '|<BE:(\d+):(\d+)>|i';
        if (preg_match($be_match, $date_id)) {
            $date_id = preg_replace($be_match, $beid_replace, $date_id);

        } else {

            $beid_replace = "<a href=\"http://be.2ch.net/test/p.php?i=\$1&u=d:http://{$this->thread->host}/test/read.cgi/{$this->thread->bbs}/{$this->thread->key}/{$i}\"{$_conf['ext_win_target_at']}>?\$2</a>";
            $date_id = preg_replace('|BE: ?(\d+)-(#*)|i', $beid_replace, $date_id);
        }

        return $date_id;
    }

    // }}}
    // {{{ ngAbornCheck()

    /**
     * NGځ[`FbN
     */
    public function ngAbornCheck($code, $resfield, $ic = FALSE)
    {
        global $ngaborns;

        //$GLOBALS['debug'] && $GLOBALS['profiler']->enterSection('ngAbornCheck()');

        if (isset($ngaborns[$code]['data']) && is_array($ngaborns[$code]['data'])) {
            $bbs = $this->thread->bbs;
            $title = $this->thread->ttitle_hc;

            foreach ($ngaborns[$code]['data'] as $k => $v) {
                // `FbN
                if (isset($v['bbs']) && in_array($bbs, $v['bbs']) == FALSE) {
                    continue;
                }

                // ^Cg`FbN
                if (isset($v['title']) && stristr($title, $v['title']) === FALSE) {
                    continue;
                }

                // [h`FbN
                // K\
                if (!empty($v['regex'])) {
                    $re_method = $v['regex'];
                    /*if ($re_method($v['word'], $resfield, $matches)) {
                        $this->ngAbornUpdate($code, $k);
                        //$GLOBALS['debug'] && $GLOBALS['profiler']->leaveSection('ngAbornCheck()');
                        return htmlspecialchars($matches[0], ENT_QUOTES);
                    }*/
                     if ($re_method($v['word'], $resfield)) {
                        $this->ngAbornUpdate($code, $k);
                        //$GLOBALS['debug'] && $GLOBALS['profiler']->leaveSection('ngAbornCheck()');
                        return $v['cond'];
                    }
               // 啶𖳎(1)
                } elseif (!empty($v['ignorecase'])) {
                    if (stristr($resfield, $v['word'])) {
                        $this->ngAbornUpdate($code, $k);
                        //$GLOBALS['debug'] && $GLOBALS['profiler']->leaveSection('ngAbornCheck()');
                        return $v['cond'];
                    }
                // 啶𖳎(2)
                } elseif ($ic) {
                    if (stristr($resfield, $v['word'])) {
                        $this->ngAbornUpdate($code, $k);
                        //$GLOBALS['debug'] && $GLOBALS['profiler']->leaveSection('ngAbornCheck()');
                        return $v['cond'];
                    }
                // Pɕ񂪊܂܂邩ǂ`FbN
                } else {
                    if (strpos($resfield, $v['word']) !== false) {
                        $this->ngAbornUpdate($code, $k);
                        //$GLOBALS['debug'] && $GLOBALS['profiler']->leaveSection('ngAbornCheck()');
                        return $v['cond'];
                    }
                }
            }
        }

        //$GLOBALS['debug'] && $GLOBALS['profiler']->leaveSection('ngAbornCheck()');
        return false;
    }

    // }}}
    // {{{ abornResCheck()

    /**
     * 背X̓ځ[`FbN
     */
    public function abornResCheck($resnum)
    {
        global $ngaborns;

        $t = $this->thread;
        $target = $t->host . '/' . $t->bbs . '/' . $t->key . '/' . $resnum;

        if (isset($ngaborns['aborn_res']['data']) && is_array($ngaborns['aborn_res']['data'])) {
            foreach ($ngaborns['aborn_res']['data'] as $k => $v) {
                if ($ngaborns['aborn_res']['data'][$k]['word'] == $target) {
                    $this->ngAbornUpdate('aborn_res', $k);
                    return true;
                }
            }
        }
        return false;
    }

    // }}}
    // {{{ ngAbornUpdate()

    /**
     * NG/ځ`Ɖ񐔂XV
     */
    public function ngAbornUpdate($code, $k)
    {
        global $ngaborns;

        if (isset($ngaborns[$code]['data'][$k])) {
            $ngaborns[$code]['data'][$k]['lasttime'] = date('Y/m/d G:i'); // HITԂXV
            if (empty($ngaborns[$code]['data'][$k]['hits'])) {
                $ngaborns[$code]['data'][$k]['hits'] = 1; // HIT
            } else {
                $ngaborns[$code]['data'][$k]['hits']++; // HIT񐔂XV
            }
        }
    }

    // }}}
    // {{{ addURLHandler()

    /**
     * [U`URLnhibZ[WURL֐jǉ
     *
     * nh͍ŏɒǉꂽ̂珇ԂɎs
     * URL̓nh̕ԂlijŒu
     * FALSEAꍇ͎̃nhɏς˂
     *
     * [U`URLnḧ
     *  1. string $url  URL
     *  2. array  $purl URLparse_url()
     *  3. string $str  p^[Ƀ}b`AURLƓƂ
     *  4. object $aShowThread ĂяõIuWFNg
     * ł
     * FALSEԂAŏ邾̊֐o^Ă悢
     *
     * @param   callback $function  R[obN\bh
     * @return  void
     * @access  public
     * @todo    [U`URLnh̃I[g[h@\
     */
    public function addURLHandler($function)
    {
        $this->_user_url_handlers[] = $function;
    }

    // }}}
    // {{{ getFilterTarget()

    /**
     * XtB^Õ^[Qbg𓾂
     */
    public function getFilterTarget($ares, $i, $name, $mail, $date_id, $msg)
    {
        switch ($GLOBALS['res_filter']['field']) {
            case 'name':
                $target = $name; break;
            case 'mail':
                $target = $mail; break;
            case 'date':
                $target = preg_replace('| ?ID:[0-9A-Za-z/.+?]+.*$|', '', $date_id); break;
            case 'id':
                if ($target = preg_replace('|^.*ID:([0-9A-Za-z/.+?]+).*$|', '$1', $date_id)) {
                    break;
                } else {
                    return '';
                }
            case 'msg':
                $target = $msg; break;
            default: // 'hole'
                $target = strval($i) . '<>' . $ares;
        }

        $target = @strip_tags($target, '<>');

        return $target;
    }

    // }}}
    // {{{ filterMatch()

    /**
     * XtB^Õ}b`
     */
    public function filterMatch($target, $resnum)
    {
        global $_conf;
        global $filter_hits, $filter_range;

        $failed = ($GLOBALS['res_filter']['match'] == 'off') ? TRUE : FALSE;

        if ($GLOBALS['res_filter']['method'] == 'and') {
            $words_fm_hit = 0;
            foreach ($GLOBALS['words_fm'] as $word_fm_ao) {
                if (StrCtl::filterMatch($word_fm_ao, $target) == $failed) {
                    if ($GLOBALS['res_filter']['match'] != 'off') {
                        return false;
                    } else {
                        $words_fm_hit++;
                    }
                }
            }
            if ($words_fm_hit == count($GLOBALS['words_fm'])) {
                return false;
            }
        } else {
            if (StrCtl::filterMatch($GLOBALS['word_fm'], $target) == $failed) {
                return false;
            }
        }

        $GLOBALS['filter_hits']++;

        if ($_conf['filtering'] && !empty($filter_range) &&
            ($filter_hits < $filter_range['start'] || $filter_hits > $filter_range['to'])
        ) {
            return false;
        }

        $GLOBALS['last_hit_resnum'] = $resnum;

        if (!$_conf['ktai']) {
            echo <<<EOP
<script type="text/javascript">
//<![CDATA[
filterCount({$GLOBALS['filter_hits']});
//]]>
</script>\n
EOP;
        }

        return true;
    }

    // }}}
}

// }}}

/*
 * Local Variables:
 * mode: php
 * coding: cp932
 * tab-width: 4
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 */
// vim: set syn=php fenc=cp932 ai et ts=4 sw=4 sts=4 fdm=marker:
