<?php
require_once P2_LIB_DIR . '/thread.class.php';

// {{{ ThreadList

/**
 * rep2 - ThreadList NX
 */
class ThreadList
{
    // {{{ properties

    public $threads;   // NXThread̃IuWFNgi[z
    public $num;       // i[ꂽThreadIuWFNg̐
    public $host;      // ex)pc.2ch.net
    public $bbs;       // ex)mac
    public $itaj;      //  ex)VEmac
    public $itaj_hd;   // HTML\pɁA htmlspecialchars() 
    public $spmode;    // ʔȊÕXyV[h
    public $ptitle;    // y[W^Cg

    // }}}
    // {{{ constructor

    /**
     * RXgN^
     */
    public function __construct()
    {
        $this->threads = array();
        $this->num = 0;
    }

    // }}}
    // {{{ setSpMode()

    /**
     * spmodeݒ肷
     */
    public function setSpMode($name)
    {
        global $_conf;

        $halfwidth = ($_conf['ktai'] && !$_conf['iphone']);

        switch ($name) {
        case 'recent':
            $this->spmode = $name;
            $this->ptitle = $halfwidth ? 'ŋߓǂ񂾽' : 'ŋߓǂ񂾃X';
            break;
        case 'res_hist':
            $this->spmode = $name;
            $this->ptitle = 'ݗ';
            break;
        case 'fav':
            $this->spmode = $name;
            $this->ptitle = $halfwidth ? 'Cɽ' : 'CɃX';
            break;
        case 'taborn':
            $this->spmode = $name;
            $this->ptitle = $this->itaj . ($halfwidth ? ' (ݒ)' : ' (ځ[)');
            break;
        case 'soko':
            $this->spmode = $name;
            $this->ptitle = "{$this->itaj} (datq)";
            break;
        case 'palace':
            $this->spmode = $name;
            $this->ptitle = $halfwidth ? 'ڂ̓a' : 'X̓a';
            break;
        case 'merge_favita':
            $this->spmode = $name;
            if ($_conf['expack.misc.multi_favs']) {
                $this->ptitle = str_replace(array('&gt;', '&lt;', '&quot;', '&#039;'),
                                            array('>', '<', '"', "'"),
                                            FavSetManager::getFavSetPageTitleHt('m_favita_set', 'Cɔ')
                                            ) . ' (܂Ƃ)';
            } else {
                $this->ptitle = 'Cɔ (܂Ƃ)';
            }
            break;
        }
    }

    // }}}
    // {{{ setIta()

    /**
     *  Iɔihost, bbs, jZbg
     */
    public function setIta($host, $bbs, $itaj = "")
    {
        $this->host = $host;
        $this->bbs = $bbs;
        $this->setItaj($itaj);

        return true;
    }

    // }}}
    // {{{ setItaj()

    /**
     * Zbg
     */
    public function setItaj($itaj)
    {
        if ($itaj) {
            $this->itaj = $itaj;
        } else {
            $this->itaj = $this->bbs;
        }
        $this->itaj_hd = htmlspecialchars($this->itaj, ENT_QUOTES);
        $this->ptitle = $this->itaj;

        return true;
    }

    // }}}
    // {{{ readList()

    /**
     *  readList \bh
     */
    public function readList()
    {
        global $_conf, $_info_msg_ht;

        //$GLOBALS['debug'] && $GLOBALS['profiler']->enterSection('readList()');

        if ($this->spmode) {

            // [J̗t@C ǂݍ
            if ($this->spmode == "recent") {
                if ($lines = FileCtl::file_read_lines($_conf['rct_file'])) {
                    //$_info_msg_ht = "<p>͋ۂł</p>";
                    //return false;
                }

            // [J̏ݗt@C ǂݍ
            } elseif ($this->spmode == "res_hist") {
                $rh_idx = $_conf['pref_dir']."/p2_res_hist.idx";
                if ($lines = FileCtl::file_read_lines($rh_idx)) {
                    //$_info_msg_ht = "<p>ݗ͋ۂł</p>";
                    //return false;
                }

            //[ĴCɃt@C ǂݍ
            } elseif ($this->spmode == "fav") {
                if ($lines = FileCtl::file_read_lines($_conf['favlist_file'])) {
                    //$_info_msg_ht = "<p>CɃX͋ۂł</p>";
                    //return false;
                }

            // Cɔ܂Ƃ߂ēǂݍ
            } elseif ($this->spmode == "merge_favita") {
                require_once P2_LIB_DIR . '/SubjectTxt.class.php';

                $favitas = array();

                if (file_exists($_conf['favita_path'])) {
                    foreach (file($_conf['favita_path']) as $l) {
                        if (preg_match("/^\t?(.+?)\t(.+?)\t.+?\$/", rtrim($l), $m)) {
                            $favitas[] = array('host' => $m[1], 'bbs' => $m[2]);
                        }
                    }
                }

                if (empty($_REQUEST['norefresh']) &&
                    !(empty($_REQUEST['refresh']) && isset($_REQUEST['word'])) &&
                    extension_loaded('http')
                ) {
                    require_once P2_LIB_DIR . '/p2httpext.class.php';
                    P2HttpRequestPool::fetchSubjectTxt($favitas);
                    $GLOBALS['expack.subject.multi-threaded-download.done'] = true;
                }

                $lines = array();
                $i = 0;

                foreach ($favitas as $ita) {
                    $aSubjectTxt = new SubjectTxt($ita['host'], $ita['bbs']);
                    $k = (float)sprintf('0.%d', ++$i);

                    if (is_array($aSubjectTxt->subject_lines)) {
                        $j = 0;

                        foreach ($aSubjectTxt->subject_lines as $l) {
                            if (preg_match('/^([0-9]+)\\.(?:dat|cgi)(?:,|<>)(.+) ?(?:\\(|i)([0-9]+)(?:\\)|j)/', $l, $m)) {
                                $lines[] = array(
                                    'key' => $m[1],
                                    'ttitle' => rtrim($m[2]),
                                    'rescount' => (int)$m[3],
                                    'host' => $ita['host'],
                                    'bbs' => $ita['bbs'],
                                    'torder' => ++$j + $k,
                                );
                            }
                        }
                    }
                }

            // p2_threads_aborn.idx ǂݍ
            } elseif ($this->spmode == "taborn") {
                $dat_host_dir = P2Util::datDirOfHost($this->host);
                $lines = FileCtl::file_read_lines($dat_host_dir."/".$this->bbs."/p2_threads_aborn.idx");

            // spmodedatqɂ̏ꍇ ======================
            } elseif ($this->spmode == "soko") {

                $dat_host_dir = P2Util::datDirOfHost($this->host);
                $idx_host_dir = P2Util::idxDirOfHost($this->host);

                $dat_bbs_dir = $dat_host_dir."/".$this->bbs;
                $idx_bbs_dir = $idx_host_dir."/".$this->bbs;

                $dat_pattern = '/([0-9]+)\.dat$/';
                $idx_pattern = '/([0-9]+)\.idx$/';

                $lines = array();

                //$GLOBALS['debug'] && $GLOBALS['profiler']->enterSection('dat'); //
                // datOfBNg𑖍ČǗdatidxt =================
                if ($cdir = dir($dat_bbs_dir)) { // or die ("OfBNgȂI");
                    // fBNg
                    while ($entry = $cdir->read()) {
                        if (preg_match($dat_pattern, $entry, $matches)) {
                            $theidx = $idx_bbs_dir."/".$matches[1].".idx";
                            if (!file_exists($theidx)) {
                                if ($datlines = FileCtl::file_read_lines($dat_bbs_dir . '/' . $entry, FILE_IGNORE_NEW_LINES)) {
                                    $firstdatline = $datlines[0];
                                    if (strpos($firstdatline, '<>') !== false) {
                                        $datline_sepa = "<>";
                                    } else {
                                        $datline_sepa = ",";
                                    }
                                    $d = explode($datline_sepa, $firstdatline);
                                    $atitle = $d[4];
                                    $gotnum = sizeof($datlines);
                                    $readnum = $gotnum;
                                    $anewline = $readnum + 1;
                                    $data = array($atitle, $matches[1], '', $gotnum, '',
                                                $readnum, '', '', '', $anewline,
                                                '', '', '');
                                    P2Util::recKeyIdx($theidx, $data);
                                }
                            }
                            // array_push($lines, $idl[0]);
                        }
                    }
                    $cdir->close();
                }
                //$GLOBALS['debug'] && $GLOBALS['profiler']->leaveSection('dat');//

                //$GLOBALS['debug'] && $GLOBALS['profiler']->enterSection('idx');//
                // {{{ idxOfBNg𑖍idx𒊏oăXg
                if ($cdir = dir($idx_bbs_dir)) { // or die ("OfBNgȂI");
                    // fBNg
                    while ($entry = $cdir->read()) {
                        if (preg_match($idx_pattern, $entry)) {
                            $idl = FileCtl::file_read_lines($idx_bbs_dir."/".$entry);
                            if (is_array($idl)) {
                                array_push($lines, $idl[0]);
                            }
                        }
                    }
                    $cdir->close();
                }
                // }}}
                //$GLOBALS['debug'] && $GLOBALS['profiler']->leaveSection('idx');//

            // X̓ȁꍇ  // p2_palace.idx ǂݍ
            } elseif ($this->spmode == "palace") {
                $palace_idx = $_conf['pref_dir']. '/p2_palace.idx';
                if ($lines = FileCtl::file_read_lines($palace_idx)) {
                    // $_info_msg_ht = "<p>a͂ǂł</p>";
                    // return false;
                }
            }

        // IC subject.txt ǂݍށispmodełȂꍇj
        } else {
            require_once P2_LIB_DIR . '/SubjectTxt.class.php';
            $aSubjectTxt = new SubjectTxt($this->host, $this->bbs);
            $lines = $aSubjectTxt->subject_lines;

        }

        //$GLOBALS['debug'] && $GLOBALS['profiler']->leaveSection('readList()');

        return $lines;
    }

    // }}}
    // {{{ addThread()

    /**
     *  addThread \bh
     */
    public function addThread(Thread $aThread)
    {
        //$GLOBALS['debug'] && $GLOBALS['profiler']->enterSection('addThread()');

        $this->threads[] = $aThread;
        $this->num++;

        //$GLOBALS['debug'] && $GLOBALS['profiler']->leaveSection('addThread()');

        return $this->num;
    }

    // }}}
}

// }}}

/*
 * Local Variables:
 * mode: php
 * coding: cp932
 * tab-width: 4
 * c-basic-offset: 4
 * indent-tabs-mode: nil
 * End:
 */
// vim: set syn=php fenc=cp932 ai et ts=4 sw=4 sts=4 fdm=marker:
